﻿Imports System.Runtime.InteropServices
Imports System.Threading
Imports System.Diagnostics
Imports System.IO
Public Class Form1


    Public Structure PROCESSENTRY32

        '''DWORD->unsigned int
        Public dwSize As Integer

        '''DWORD->unsigned int
        Public cntUsage As Integer

        '''DWORD->unsigned int
        Public th32ProcessID As Integer

        '''DWORD->unsigned int
        Public th32DefaultHeapID As Integer

        '''DWORD->unsigned int
        Public th32ModuleID As Integer

        '''DWORD->unsigned int
        Public cntThreads As Integer

        '''DWORD->unsigned int
        Public th32ParentProcessID As Integer

        '''LONG->int
        Public pcPriClassBase As Integer

        '''DWORD->unsigned int
        Public dwFlags As Integer

        '''TCHAR[260]
        <System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=260)> _
        Public szExeFile As String

        '''DWORD->unsigned int
        Public th32MemoryBase As Integer

        '''DWORD->unsigned int
        Public th32AccessKey As Integer
    End Structure



    Public Structure SECURITY_ATTRIBUTES

        '''DWORD->unsigned int
        Public nLength As Integer

        '''LPVOID->void*
        Public lpSecurityDescriptor As IntPtr

        '''BOOL->int
        <System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.Bool)> _
        Public bInheritHandle As Boolean
    End Structure

    'get process
    <DllImport("Toolhelp.dll", EntryPoint:="CreateToolhelp32Snapshot")> _
    Public Shared Function CreateToolhelp32Snapshot(ByVal flags As Integer, ByVal processid As Integer) As IntPtr
    End Function

    'Search first process
    <DllImport("Toolhelp.dll", EntryPoint:="Process32First")> _
    Public Shared Function Process32First(ByVal flags As Integer, ByRef processid As PROCESSENTRY32) As Boolean
    End Function

    'search next process
    <DllImport("Toolhelp.dll", EntryPoint:="Process32Next")> _
    Public Shared Function Process32Next(ByVal hSnapshot As IntPtr, ByRef lppe As PROCESSENTRY32) As Boolean
    End Function


    <DllImport("Toolhelp.dll", EntryPoint:="CloseToolhelp32Snapshot")> _
    Public Shared Function CloseToolhelp32Snapshot(ByVal hSnapshot As IntPtr) As Boolean
    End Function


    <DllImport("Coredll.dll", EntryPoint:="CreateMutex")> _
    Public Shared Function CreateMutex(ByVal lpsa As SECURITY_ATTRIBUTES, ByVal bInitialOwner As Boolean, ByVal lpName As String) As IntPtr
    End Function

    <DllImport("Coredll.dll", EntryPoint:="GetLastError")> _
    Public Shared Function GetLastError() As Integer
    End Function

    <DllImport("Coredll.dll", EntryPoint:="CloseHandle")> _
    Public Shared Function CloseHandle(ByVal Handle As IntPtr) As Boolean
    End Function

    'the program name
    Dim FileName As String

    'the program path
    Dim FilePath As String

    Dim flag As Boolean = False

    'watch dog time(default is 1000 ms)
    Dim looptime As Integer = 1000

    Dim myThread As Thread



    Sub ThreadFun()

        Dim lRes As Boolean = False
        Dim procEntry As PROCESSENTRY32 = New PROCESSENTRY32()
        procEntry.dwSize = Marshal.SizeOf(procEntry)
        Dim lProcSnapshot As IntPtr = New IntPtr()
        Dim IsRun As Boolean = True


        While (True)
            'get process
            lProcSnapshot = CreateToolhelp32Snapshot(2, 0)

            If (lProcSnapshot <> -1) Then
                procEntry.dwSize = Marshal.SizeOf(procEntry)
                'find first process
                lRes = Process32First(lProcSnapshot, procEntry)
                While (lRes)
                    'compare process file name and setting file name
                    If (procEntry.szExeFile = FileName) Then
                        'if get process file name and setting program is equal, set 'IsRun' flag as true
                        IsRun = True
                    End If
                    'get next process
                    lRes = Process32Next(lProcSnapshot, procEntry)
                    System.Threading.Thread.Sleep(5)

                End While

                If (IsRun = False) Then
                    'if it not find setting program, it will call up the program
                    Process.Start(FilePath, "")

                End If
                'clear flag as false
                IsRun = False
                Thread.Sleep(looptime)


            End If
            'close search process handle
            CloseToolhelp32Snapshot(lProcSnapshot)
        End While

    End Sub



    Public Function GetFileName(ByVal Path As String) As String
        Dim name As String
        Dim index = Path.LastIndexOf("\")
        name = Path.Substring(index + 1)
        Return name
    End Function

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        If (flag <> True) Then
            MessageBox.Show("You must select a program!!")
            Return
        End If
        looptime = Integer.Parse(txtWDT.Text)
        Dim sa As SECURITY_ATTRIBUTES = New SECURITY_ATTRIBUTES()

        Dim hMutex As IntPtr = CreateMutex(sa, False, "FiXiNdUsOfTiDlE")

        'Error code ERROR_ALREADY_EXISTS is 183.
        If (GetLastError() = 183) Then
            CloseHandle(hMutex)
            Return
        End If


        myThread = New Thread(AddressOf ThreadFun)
        myThread.Start()


    End Sub

    Private Sub btnSelectFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectFile.Click
        'show open file dialog
        OpenFileDialog1.ShowDialog()
        'check select file is exit
        If (File.Exists(OpenFileDialog1.FileName)) Then
            'get file namr from select file path
            FileName = GetFileName(OpenFileDialog1.FileName)
            txtPath.Text = OpenFileDialog1.FileName
            FilePath = txtPath.Text
            flag = True
        End If
    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        myThread.Abort()
        myThread.Join()
    End Sub
End Class
