﻿Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Namespace WatchDog
    Public Partial Class Form1
        Inherits Form
        Dim WD_TYPE As Integer = PACNET.Sys.WDT.PAC_WDT_OS
        Dim WatchDogTime As UInteger = 10

        Private SecondsLeft As UInteger

        Public Sub New()
            InitializeComponent()
            timer1.Interval = 1000
            comboBox1.SelectedIndex = 0
        End Sub

        Private Sub button3_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
            'Refresh
            PACNET.Sys.WDT.RefreshWatchDog(WD_TYPE)
            SecondsLeft = WatchDogTime
        End Sub

        Private Sub button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
            'Enable
            If comboBox1.SelectedIndex = 0 Then
                WD_TYPE = PACNET.Sys.WDT.PAC_WDT_HW
            End If

            WatchDogTime = Convert.ToUInt32(textBox1.Text)
            SecondsLeft = WatchDogTime

            PACNET.Sys.WDT.EnableWatchDog(WD_TYPE, WatchDogTime)
            SecondsLeft = WatchDogTime
            timer1.Enabled = True
        End Sub

        Private Sub button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
            'Disable
            PACNET.Sys.WDT.DisableWatchDog(WD_TYPE)
            timer1.Enabled = False
            label1.Text = "X"
        End Sub

        Private Sub timer1_Tick_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
            'used for count-down
            label1.Text = SecondsLeft.ToString()
            SecondsLeft -= 1
        End Sub
    End Class
End Namespace
